﻿
using Infragistics.Windows;
using Infragistics.Windows.Automation.Peers.DataPresenter;
using Infragistics.Windows.Controls;
using Infragistics.Windows.DataPresenter;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Diagnostics;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Automation.Peers;
using System.Windows.Automation.Provider;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Forms;
using System.Windows.Input;
using System.Windows.Markup;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace test
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        bool _refreshRequired = true;
        public MainWindow()
        {
            InitializeComponent();
            xdg.DataContext = new ViewModel();

        }

        private void xdg_InitializeRecord(object sender, Infragistics.Windows.DataPresenter.Events.InitializeRecordEventArgs e)
        {
            try
            {
                _refreshRequired = true;
                if (e.Record is DataRecord)
                {

                    Dispatcher.BeginInvoke(new Action(() =>
                    {
                        ((DataRecord)e.Record).RefreshSortPosition();
                        ((DataRecord)e.Record).RefreshFilters();

                    }), System.Windows.Threading.DispatcherPriority.Background);
                }
            }
            catch (Exception)
            { }
        }
    }

    public class ViewModel : INotifyPropertyChanged
    {
        private Timer _timer;


        public ViewModel()
        {
            GridData = new ObservableCollection<Data>();
            GridData = Data.GetData(10, 1, 10);
            _timer = new Timer();
            _timer.Interval = 1000;
            _timer.Tick += _timer_Tick;
            _timer.Start();
        }

        private void _timer_Tick(object sender, EventArgs e)
        {
            Random rnd = new Random();
            GridData.Add(new Data()
            {
                High = rnd.Next(0,100),
                Value = rnd.Next(0, 100),
                Label = "Test"
            });
        }

        private ObservableCollection<Data> _gridData;

        public ObservableCollection<Data> GridData
        {
            get { return _gridData; }
            set
            {
                _gridData = value;
                PropChanged("GridData");
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        public void PropChanged(string name)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(name));
        }
    }
    public class Data : INotifyPropertyChanged
    {
        private int high;
        private int value;
        private string label;

        public string Label
        {
            get { return label; }
            set
            {
                label = value;
                PropChanged("Label");
            }
        }

        public int High
        {
            get { return high; }
            set
            {
                high = value;
                PropChanged("High");
            }
        }

        public int Value
        {
            get { return value; }
            set
            {
                this.value = value;
                PropChanged("Value");
            }
        }

        public static ObservableCollection<Data> GetData(int points, int rangeStart, int rangeEnd)
        {
            ObservableCollection<Data> data = new ObservableCollection<Data>();
            Random r = new Random();
            for (int i = 0; i < points; i++)
            {
                data.Add(new Data
                {
                    Label = "Item " + r.Next(1,20),
                    High = r.Next(rangeStart, rangeEnd),
                    Value = r.Next(rangeStart, rangeEnd)
                });
            }

            return data;
        }

        public event PropertyChangedEventHandler PropertyChanged;

        public void PropChanged(string name)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(name));
        }
    }



}
